import java.io.*;

public class Demo
{
    public static void fileWriter() throws IOException {
        FileWriter fw = new FileWriter("out.txt");
        
        fw.write('a');
        fw.write("bcd");
        fw.write(System.getProperty("line.separator"));
        fw.write('š');
        
        fw.close();
    }
    
    public static void bufferedWriter() throws IOException {
        BufferedWriter bw = new BufferedWriter(new FileWriter("out.txt"));
        //BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(new FileOutputStream("out.txt"), "windows-1250"));
        
        bw.write('a');
        bw.write("bcd");
        bw.newLine();
        bw.write('š');
        //fw.write("ahoj");
        
        bw.close();
    }
    
    public static void bufferedWriter(Writer writer) throws IOException {
        BufferedWriter bw = new BufferedWriter(writer);
        
        bw.write('a');
        bw.write("bcd");
        bw.newLine();
        bw.write('š');
        
        //bw.close();
        bw.flush();
    }
    
    public static void bufferedWriterDemo() throws IOException {
        FileWriter fw = new FileWriter("out.txt");
        bufferedWriter(fw);
        //fw.write('g');
        fw.close();
    }
    
    public static void fileOutputStream() throws IOException {
        FileOutputStream fw = new FileOutputStream("out.bin");
        
        fw.write('a');
        fw.write('š');
        fw.write('č');
        fw.write('ž');
        fw.write('ý');
        
        fw.close();
    }
    
    public static void bufferedWriter2(OutputStream os) throws IOException {
        BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(os, "windows-1250"));
        
        bw.write('a');
        bw.write("bcd");
        bw.newLine();
        bw.write('š');
        
        bw.flush();
    }
    
    public static void fileReader() throws IOException {
        FileReader fr = new FileReader("out.txt");
        
        int c = fr.read();
        while (c != -1) {
            System.out.println((char) c);
            c = fr.read();
        }
        
        fr.close();
    }

    public static void bufferedReader() throws IOException {
        BufferedReader br = new BufferedReader(new FileReader("out.txt"));

        for (String line = br.readLine(); line != null; line = br.readLine()) {
            System.out.println(line);
        }
        
        br.close();
    }

    public static void fileWriterCatchException() {
        FileWriter fw = null;
        try {
            fw = new FileWriter("out.txt");

            fw.write('a');
            fw.write("bcd");
            fw.write(System.getProperty("line.separator"));
            fw.write('š');
        } catch(IOException ex) {
            ex.printStackTrace();
            return;
        } finally {
            if (fw != null) {
                try {
                    fw.close();
                } catch(IOException ex) {
                }
            }
        }
    }
    
    public static void fileWriterCatchException2() {
        try {
            FileWriter fw = new FileWriter("out.txt");

            try {
                fw.write('a');
                fw.write("bcd");
                fw.write(System.getProperty("line.separator"));
                fw.write('š');
            } finally {
                fw.close();
            }
        } catch(IOException ex) {
            ex.printStackTrace();
            return;
        }
    }
    
}
